// SSR - Super Sniper Rifle, can penetrate through walls & players
// By Mr.Self-Destruct

class SuperSniperRifle extends SniperRifle;

// Penetration through walls
var() float Thick;
// Penetration through pawns
var() float PawnThick;
// First trace?
var bool bFirst;

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
  local UT_Shellcase s;
  local int NormShot;
  local int HeadShot;

  NormShot=45;
  HeadShot=100;

  // If first shot, spawn shell case
  if (bFirst)
  {
    s = Spawn(class'UT_ShellCase',, '', Owner.Location + CalcDrawOffset() + 30 * X + (2.8 * FireOffset.Y+5.0) * Y - Z * 1);
    if ( s != None )
    {
      s.DrawScale = 2.0;
      s.Eject(((FRand()*0.3+0.4)*X + (FRand()*0.2+0.2)*Y + (FRand()*0.3+1.0) * Z)*160);
    }
  }
  // If second shot, reduce damage
  else
  {
    NormShot=25;
    HeadShot=75;
  }
  if (Other == Level) 
    Spawn(class'UT_HeavyWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
  else if ( (Other != self) && (Other != Owner) && (Other != None) ) 
  {
    if ( Other.bIsPawn )
      Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);
    if ( Other.bIsPawn && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight) 
      && (instigator.IsA('PlayerPawn') || (instigator.IsA('Bot') && !Bot(Instigator).bNovice)) )
      Other.TakeDamage(HeadShot, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);
    else
      Other.TakeDamage(NormShot,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);
    if ( !Other.bIsPawn && !Other.IsA('Carcass') )
      spawn(class'UT_SpriteSmokePuff',,,HitLocation+HitNormal*9);  
  }
}

function TraceFire( float Accuracy )
{
  local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
  local actor Other;
  local Pawn PawnOwner;
  local float Penetration;

  PawnOwner = Pawn(Owner);

  Owner.MakeNoise(PawnOwner.SoundDampening);
  GetAxes(PawnOwner.ViewRotation,X,Y,Z);
  // First trace
  StartTrace = Owner.Location + PawnOwner.Eyeheight * Z; 
  AdjustedAim = PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, False);  
  X = vector(AdjustedAim);
  EndTrace = StartTrace + 10000 * X;
  Other = PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
  // Deal with first target
  bFirst=True;
  ProcessTraceHit(Other, HitLocation, HitNormal, X,Y,Z);

  // Second trace, taking into account previous target
  if (Other.IsA('Pawn'))
    Penetration = PawnThick;
  else
    Penetration = Thick;
  StartTrace = HitLocation + HitNormal + (Penetration * X);
  AdjustedAim = PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, False);  
  X = vector(AdjustedAim);
  EndTrace = StartTrace + 10000 * X;
  Other = PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
  // Deal with second target
  bFirst=False;
  ProcessTraceHit(Other, HitLocation, HitNormal, X,Y,Z);
}

defaultproperties
{
     Thick=26.000000
     PawnThick=36.000000
     PickupMessage="You got a Super Sniper Rifle."
     ItemName="Super Sniper Rifle"
}
